| Exiv2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Exiv2::ValueType< T > Class Template Reference

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::ValueType< T >:
[legend]

## Public Types
using | UniquePtr = std::unique_ptr<ValueType<T>>
| Shortcut for a ValueType<T> auto pointer.
Public Types inherited from Exiv2::Value
using | UniquePtr = std::unique_ptr<Value>
| Shortcut for a Value auto pointer.

## Public Member Functions
int64_t | toInt64 (size_t n) const
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
int64_t | toInt64 (size_t n) const
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
int64_t | toInt64 (size_t n) const
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
int64_t | toInt64 (size_t n) const
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (size_t n) const
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n) const
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
Creators
| ValueType ()
| Default Constructor.
| ValueType (const byte *buf, size_t len, ByteOrder byteOrder, TypeId typeId=getType< T >())
| Constructor.
| ValueType (const T &val, TypeId typeId=getType< T >())
| Constructor.
| ValueType (const ValueType< T > &rhs)
| Copy constructor.
| ~ValueType () override
| Virtual destructor.
Manipulators
ValueType< T > & | operator= (const ValueType< T > &rhs)
| Assignment operator.
int | read (const byte *buf, size_t len, ByteOrder byteOrder) override
| Read the value from a character buffer.
int | read (const std::string &buf) override
| Set the data from a string of values of type T (e.g., "0 1 2 3" or "1/2 1/3 1/4" depending on what T is). Generally, the accepted input format is the same as that produced by the write() method.
int | setDataArea (const byte *buf, size_t len) override
| Set the data area. This method copies (clones) the buffer pointed to by buf.
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()=default
| Virtual destructor.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
UniquePtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors
using | ValueList = std::vector<T>
| Container for values.
using | iterator = typename std::vector<T>::iterator
| Iterator type defined for convenience.
using | const_iterator = typename std::vector<T>::const_iterator
| Const iterator type defined for convenience.
ValueList | value_
| The container for all values. In your application, if you know what subclass of Value you're dealing with (and possibly the T) then you can access this STL container through the usual standard library functions.
UniquePtr | clone () const
size_t | copy (byte *buf, ByteOrder byteOrder) const override
| Write value to a data buffer.
size_t | count () const override
| Return the number of components of the value.
size_t | size () const override
| Return the size of the value in bytes.
std::ostream & | write (std::ostream &os) const override
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
std::string | toString (size_t n) const override
| Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.
int64_t | toInt64 (size_t n=0) const override
| Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.
uint32_t | toUint32 (size_t n=0) const override
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
float | toFloat (size_t n=0) const override
| Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.
Rational | toRational (size_t n=0) const override
| Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.
size_t | sizeDataArea () const override
| Return the size of the data area.
DataBuf | dataArea () const override
| Return a copy of the data area in a DataBuf. The caller owns this copy and DataBuf ensures that it will be deleted.

## Additional Inherited Members
static UniquePtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
| Value (const Value &)=default
Value & | operator= (const Value &)=default
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
bool | ok_ {true}
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

template<typename T>
class Exiv2::ValueType< T >

Template for a Value of a basic type. This is used for unsigned and signed short, long and rationals.

## Member Function Documentation

## ◆ copy()

template<typename T>

size_t Exiv2::ValueType< T >::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder ) const
| override virtual

Write value to a data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Parameters

  buf | Data buffer to write to.
  byteOrder | Applicable byte order (little or big endian).

Returns
  Number of bytes written.

Implements Exiv2::Value.

References Exiv2::toData(), and value_.

## ◆ count()

template<typename T>

size_t Exiv2::ValueType< T >::count | ( |  | ) | const
| override virtual

Return the number of components of the value.

Implements Exiv2::Value.

References value_.

## ◆ dataArea()

template<typename T>

DataBuf Exiv2::ValueType< T >::dataArea | ( |  | ) | const
| override virtual

Return a copy of the data area in a DataBuf. The caller owns this copy and DataBuf ensures that it will be deleted.

Reimplemented from Exiv2::Value.

## ◆ read() [1/2]

template<typename T>

int Exiv2::ValueType< T >::read | ( | const byte * | buf,
|  | size_t | len,
|  | ByteOrder | byteOrder )
| override virtual

Read the value from a character buffer.

Parameters

  buf | Pointer to the data buffer to read from
  len | Number of bytes in the data buffer
  byteOrder | Applicable byte order (little or big endian).

Returns
  0 if successful.

Implements Exiv2::Value.

References Exiv2::getValue(), Exiv2::Value::typeId(), Exiv2::TypeInfo::typeSize(), and value_.

Referenced by ValueType().

## ◆ read() [2/2]

template<typename T>

int Exiv2::ValueType< T >::read | ( | const std::string & | buf | ) |
| override virtual

Set the data from a string of values of type T (e.g., "0 1 2 3" or "1/2 1/3 1/4" depending on what T is). Generally, the accepted input format is the same as that produced by the write() method.

Implements Exiv2::Value.

References value_.

## ◆ setDataArea()

template<typename T>

int Exiv2::ValueType< T >::setDataArea | ( | const byte * | buf,
|  | size_t | len )
| override virtual

Set the data area. This method copies (clones) the buffer pointed to by buf.

Reimplemented from Exiv2::Value.

## ◆ size()

template<typename T>

size_t Exiv2::ValueType< T >::size | ( |  | ) | const
| override virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

References Exiv2::Value::typeId(), Exiv2::TypeInfo::typeSize(), and value_.

## ◆ sizeDataArea()

template<typename T>

size_t Exiv2::ValueType< T >::sizeDataArea | ( |  | ) | const
| override virtual

Return the size of the data area.

Reimplemented from Exiv2::Value.

## ◆ toFloat() [1/3]

float Exiv2::ValueType< URational >::toFloat | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toFloat() [2/3]

float Exiv2::ValueType< Rational >::toFloat | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toFloat() [3/3]

template<typename T>

float Exiv2::ValueType< T >::toFloat | ( | size_t | n = 0 | ) | const
| override virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ toInt64() [1/5]

int64_t Exiv2::ValueType< URational >::toInt64 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toInt64() [2/5]

int64_t Exiv2::ValueType< Rational >::toInt64 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toInt64() [3/5]

int64_t Exiv2::ValueType< float >::toInt64 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toInt64() [4/5]

int64_t Exiv2::ValueType< double >::toInt64 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toInt64() [5/5]

template<typename T>

int64_t Exiv2::ValueType< T >::toInt64 | ( | size_t | n = 0 | ) | const
| override virtual

Convert the n-th component of the value to an int64_t. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ toRational() [1/5]

Rational Exiv2::ValueType< double >::toRational | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toRational() [2/5]

Rational Exiv2::ValueType< float >::toRational | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toRational() [3/5]

Rational Exiv2::ValueType< URational >::toRational | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toRational() [4/5]

Rational Exiv2::ValueType< Rational >::toRational | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toRational() [5/5]

template<typename T>

Rational Exiv2::ValueType< T >::toRational | ( | size_t | n = 0 | ) | const
| override virtual

Convert the n-th component of the value to a Rational. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ toString()

template<typename T>

std::string Exiv2::ValueType< T >::toString | ( | size_t | n | ) | const
| override virtual

Return the n-th component of the value as a string. The behaviour of this method may be undefined if there is no n-th component.

Reimplemented from Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ toUint32() [1/5]

uint32_t Exiv2::ValueType< URational >::toUint32 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toUint32() [2/5]

uint32_t Exiv2::ValueType< Rational >::toUint32 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toUint32() [3/5]

uint32_t Exiv2::ValueType< float >::toUint32 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toUint32() [4/5]

uint32_t Exiv2::ValueType< double >::toUint32 | ( | size_t | n | ) | const
| inline virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

## ◆ toUint32() [5/5]

template<typename T>

uint32_t Exiv2::ValueType< T >::toUint32 | ( | size_t | n = 0 | ) | const
| override virtual

Convert the n-th component of the value to a float. The behaviour of this method may be undefined if there is no n-th component.

Returns
  The converted value.

Implements Exiv2::Value.

References Exiv2::Value::ok_, and value_.

## ◆ write()

template<typename T>

std::ostream & Exiv2::ValueType< T >::write | ( | std::ostream & | os | ) | const
| override virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

References value_.

The documentation for this class was generated from the following file:

- value.hpp